#pragma once
#include <windows.h>
#include <string>
#include <list>
#define IMGCTL_RUNTIME
#include "_imgctl.h"
#include "main.h"

class CImgctl
	{
	private:
		std::string basepath;
		HMODULE handle;
		std::list<HDIB> dib_list;
	public:
		// [{֐]
		IMGCTLVERSION	_ImgctlVersion;	// DLL̃o[W擾
		IMGCTLBETA	_ImgctlBeta;		// DLL̃x[^o[W擾
		IMGCTLERROR	_ImgctlError;		// ŌɃZbgꂽG[R[h擾
		IMGCTLERRORCLEAR	_ImgctlErrorClear;		// G[R[hNA
		GETIMAGETYPE	_GetImageType;	// t@C̉摜`擾
		GETIMAGEMTYPE	_GetImageMType;	// ̉摜f[^̉摜`擾
		TODIB	_ToDIB;					// BMP,JPEG,PNGt@CDIBf[^擾
		MTODIB	_MtoDIB;				// BMP,JPEG,PNGf[^DIB擾
		
		// [DIBf[^֐]
		DELETEDIB	_DeleteDIB;			// DIBf[^̊J(dv!!)
		HEADDIB	_HeadDIB;				// DIBf[^BITMAPINFOHEADER擾
		PALETTEDIB	_PaletteDIB;		// DIBf[^̃pbgf[^擾
		PIXELDIB	_PixelDIB;			// DIBf[^̔Cӂ̓_̐F擾
		COLORDIB	_ColorDIB;			// DIBf[^̐F擾
		GETDIB	_GetDIB;				// DIBf[^̎f[^擾
		MAPDIB	_MapDIB;				// DIBf[^̎f[^ւ̃}bsO
		DATADIB	_DataDIB;				// DIBf[^̎̂ւ̃|C^擾
		CREATEDIB	_CreateDIB;			// f[^DIBf[^쐬
		COPYDIB	_CopyDIB;				// DIBf[^̕
		CUTDIB	_CutDIB;				// DIBf[^̐؂(㉺E]\)
		TURNDIB	_TurnDIB;				// DIBf[^̉](90xP)
		DIBTO24BIT	_DIBto24Bit;		// DIBf[^24rbg
		DIBTO16BIT	_DIBto16Bit;		// DIBf[^16rbg
		DIBTO16BITEX	_DIBto16BitEx;	// DIBf[^16rbg(g)
		DIBTO8BIT	_DIBto8Bit;			// DIBf[^8rbg(256F)
		// [24rbgDIBf[^֐]
		PASTEDIB	_PasteDIB;			// DIBf[^̓\t(㉺E]\)
		RESIZEDIB	_ResizeDIB;			// DIBf[^̃TCY(cێ\)
		TURNDIBEX	_TurnDIBex;			// DIBf[^̉](Cӊpx)
		
		// [RLE-DIBf[^֐]
		ISRLE	_IsRLE;					// DIBf[^RLE
		DIBTORLE	_DIBtoRLE;			// DIBf[^RLE-DIBf[^
		RLETODIB	_RLEtoDIB;			// RLE-DIBf[^DIBf[^
		
		// [Bitmap摜֐]
		DIBTOBMP	_DIBtoBMP;			// DIBf[^BMPt@C쐬
		BMPTODIB	_BMPtoDIB;			// BMPt@CDIBf[^擾
		BMPMTODIB	_BMPMtoDIB;			// BMPf[^DIBf[^擾
		
		// [JPEG摜֐]
		DIBTOJPG	_DIBtoJPG;			// DIBf[^JPEGt@C쐬
		JPGTODIB	_JPGtoDIB;			// JPEGt@CDIBf[^擾
		JPGMTODIB	_JPGMtoDIB;			// JPEGf[^DIBf[^擾
		
		// [PNG摜֐]
		DIBTOPNG	_DIBtoPNG;			// DIBf[^PNGt@C쐬
		DIBTOPNGEX	_DIBtoPNGex;		// DIBf[^PNGt@C쐬(eݒ\)
		PNGTODIB	_PNGtoDIB;			// PNGt@CDIBf[^擾
		PNGMTODIB	_PNGMtoDIB;			// PNGf[^DIBf[^擾
		PNGATODIB	_PNGAtoDIB;			// PNGt@C烿`lf[^擾
		PNGMATODIB	_PNGMAtoDIB;		// PNGf[^烿`lf[^擾
		INFOPNG	_InfoPNG;				// PNGt@Ce擾
		INFOPNGM	_InfoPNGM;			// PNGf[^e擾
		
		// [GIF摜֐]
		DIBTOGIF	_DIBtoGIF;			// DIBf[^GIFt@C쐬
		DIBTOGIFEX	_DIBtoGIFex;		// DIBf[^GIFt@C쐬(eݒ\)
		DIBTOGIFANI	_DIBtoGIFAni;		// DIBf[^z񂩂AjGIFt@C쐬B
		DIBTOGIFANIEX	_DIBtoGIFAniEx;	// V[z񂩂AjGIFt@C쐬B
		GIFTODIB	_GIFtoDIB;			// GIFt@CDIBf[^擾
		GIFMTODIB	_GIFMtoDIB;			// GIFf[^DIBf[^擾
		GIFTODIBEX	_GIFtoDIBex;		// GIFt@CDIBf[^Ɗe擾
		GIFMTODIBEX	_GIFMtoDIBex;		// GIFf[^DIBf[^擾
		
		// [tB^֐]
		GRAYDIB	_GrayDIB;				// DIBf[^̒WF
		REPLACEDIB	_ReplaceDIB;		// DIBf[^RGBl̒u
		REPAINTDIB	_RepaintDIB;		// DIBf[^̎wF̒u
		TABLEDIB	_TableDIB;			// Fϊe[uɂDIBf[^̐Fϊ
		// [Fϊe[u֐]
		TONEDIB	_ToneDIB;				// DIBf[^RGB̓xύX
		SHADEDIB	_ShadeDIB;			// DIBf[^RGB̔{ύX
		GAMMADIB	_GammaDIB;			// DIBf[^RGB̃K}lύX
		CONTRASTDIB	_ContrastDIB;		// DIBf[^RGB̃RgXgύX
		
		// [ʊ֘A֐]
		DIBTODC	_DIBtoDC;				// DIBf[^ʂ֓]
		DIBTODCEX	_DIBtoDCex;			// DIBf[^Lkĉʂ֓]
		DIBTODCEX2	_DIBtoDCex2;		// DIBf[^w胂[hŐLkĉʂ֓]
		DCTODIB	_DCtoDIB;				// DCnhDIBf[^擾
	public:
		bool IsEnable(void);
		// [{֐]
		HGLOBAL ImgctlVersion(Request&,long*);
		HGLOBAL ImgctlBeta(Request&,long*);
		HGLOBAL ImgctlError(Request&,long*);
		HGLOBAL ImgctlErrorClear(Request&,long*);
		HGLOBAL GetImageType(Request&,long*);
		HGLOBAL GetImageMType(Request&,long*);
		HGLOBAL ToDIB(Request&,long*);
		HGLOBAL MtoDIB(Request&,long*);
		
		// [DIBf[^֐]
		HGLOBAL DeleteDIB(Request&,long*);
		HGLOBAL HeadDIB(Request&,long*);
		HGLOBAL PaletteDIB(Request&,long*);
		HGLOBAL PixelDIB(Request&,long*);
		HGLOBAL ColorDIB(Request&,long*);
		HGLOBAL GetDIB(Request&,long*);
		HGLOBAL MapDIB(Request&,long*);
		HGLOBAL DataDIB(Request&,long*);
		HGLOBAL CreateDIB(Request&,long*);
		HGLOBAL CopyDIB(Request&,long*);
		HGLOBAL CutDIB(Request&,long*);
		HGLOBAL TurnDIB(Request&,long*);
		HGLOBAL DIBto24Bit(Request&,long*);
		HGLOBAL DIBto16Bit(Request&,long*);
		HGLOBAL DIBto16BitEx(Request&,long*);
		HGLOBAL DIBto8Bit(Request&,long*);
		// [24rbgDIBf[^֐]
		HGLOBAL PasteDIB(Request&,long*);
		HGLOBAL ResizeDIB(Request&,long*);
		HGLOBAL TurnDIBex(Request&,long*);
		
		// [RLE-DIBf[^֐]
		HGLOBAL IsRLE(Request&,long*);
		HGLOBAL DIBtoRLE(Request&,long*);
		HGLOBAL RLEtoDIB(Request&,long*);
		
		// [Bitmap摜֐]
		HGLOBAL DIBtoBMP(Request&,long*);
		HGLOBAL BMPtoDIB(Request&,long*);
		HGLOBAL BMPMtoDIB(Request&,long*);
		
		// [JPEG摜֐]
		HGLOBAL DIBtoJPG(Request&,long*);
		HGLOBAL JPGtoDIB(Request&,long*);
		HGLOBAL JPGMtoDIB(Request&,long*);
		
		// [PNG摜֐]
		HGLOBAL DIBtoPNG(Request&,long*);
		HGLOBAL DIBtoPNGex(Request&,long*);
		HGLOBAL PNGtoDIB(Request&,long*);
		HGLOBAL PNGMtoDIB(Request&,long*);
		HGLOBAL PNGAtoDIB(Request&,long*);
		HGLOBAL PNGMAtoDIB(Request&,long*);
		HGLOBAL InfoPNG(Request&,long*);
		HGLOBAL InfoPNGM(Request&,long*);
		
		// [GIF摜֐]
		HGLOBAL DIBtoGIF(Request&,long*);
		HGLOBAL DIBtoGIFex(Request&,long*);
		HGLOBAL DIBtoGIFAni(Request&,long*);
		HGLOBAL DIBtoGIFAniEx(Request&,long*);
		HGLOBAL GIFtoDIB(Request&,long*);
		HGLOBAL GIFMtoDIB(Request&,long*);
		HGLOBAL GIFtoDIBex(Request&,long*);
		HGLOBAL GIFMtoDIBex(Request&,long*);
		
		// [tB^֐]
		HGLOBAL GrayDIB(Request&,long*);
		HGLOBAL ReplaceDIB(Request&,long*);
		HGLOBAL RepaintDIB(Request&,long*);
		HGLOBAL TableDIB(Request&,long*);
		// [Fϊe[u֐]
		HGLOBAL ToneDIB(Request&,long*);
		HGLOBAL ShadeDIB(Request&,long*);
		HGLOBAL GammaDIB(Request&,long*);
		HGLOBAL ContrastDIB(Request&,long*);
		
		// [ʊ֘A֐]
		HGLOBAL DIBtoDC(Request&,long*);
		HGLOBAL DIBtoDCex(Request&,long*);
		HGLOBAL DIBtoDCex2(Request&,long*);
		HGLOBAL DCtoDIB(Request&,long*);
		
		// ⏕
		int _DeleteAllDIB(void);
		HGLOBAL DeleteAllDIB(Request&,long*);
		//
		CImgctl(std::string);
		~CImgctl(void);
	private:
		CImgctl(const CImgctl&){};
	};
